# This is a one of two related Makefiles for easy-DLL'ing.
# Change DYNMAKE below to the appropriate location
# The reason for two makefiles is that the .def file should never
# be automatically updated, but should be automatically created.
#
# Use like 
#
# make; make install; make clean
#
# or
#
# make definition; manually edit .DEF file; make; make install; make clean
# 
# Make realclean will erase .DEF file. Do not do this if you want to preserve
# binary compatibility between version.
#
# If you have perl you may generate .DEF file like this:
#
# make smartdefinition

# Change this location in the sample file and copy-on-write the sample ;-):

DYNMAKE = f:/emx.add/lib/Makefile.dynamic

### This should be customized for your particular library:

DEFS   =  -DHAVE_CONFIG_H -DRL_LIBRARY_VERSION="\"\\\"4.1\\\"\""
CFLAGS = -O2 -fomit-frame-pointer
#CFLAGS = -g -Dregister=
LIB = readline
LIBS = -lbtermcap_import
#LIBS = -lncurses_s
INCLUDES = -I.
#OBJECTS = readline.obj vi_mode.obj funmap.obj keymaps.obj parens.obj search.obj \
#	  rltty.obj complete.obj bind.obj isearch.obj display.obj signals.obj \
#	  history.obj tilde.obj xmalloc.obj

OBJECTS = bind.obj callback.obj complete.obj display.obj funmap.obj \
	histexpand.obj histfile.obj history.obj histsearch.obj input.obj \
	isearch.obj keymaps.obj kill.obj macro.obj nls.obj parens.obj \
	readline.obj rltty.obj search.obj shell.obj signals.obj terminal.obj \
	tilde.obj undo.obj util.obj vi_mode.obj xmalloc.obj

MYINCLUDES = readline/readline.h readline/history.h

# These two are required

# LIB = readline
# OBJECTS = readline.obj vi_mode.obj funmap.obj keymaps.obj parens.obj search.obj \
# 	  rltty.obj complete.obj bind.obj isearch.obj display.obj signals.obj \
# 	  history.obj tilde.obj xmalloc.obj

# These are optional:

# DEFS   = -DHAVE_CONFIG_H -DHAVE_STRICMP -D_POSIX_VERSION
# CFLAGS = -g
# LIBS = -ltermcap_import
# INCLUDES =

# This is used for smartdefinition: List of header files which contain
# the external names for the library.

#MYINCLUDES = $(LIB).h

# Script to use to filter out unneeded symbols 
# (entry points in DLL are case-insensitive). Comment if not needed:

# Default (remove the case-dublicate symbols completely):

SETFILTER = "FILTER=filtersym.cmd"

# No filtering:
# SETFILTER = "FILTER=@cmd /c rem"

### This is the end of customization section

RM = cmd /c del
MAKE2 =	$(MAKE) -f $(DYNMAKE) \
		LIB=$(LIB) "OBJECTS=$(OBJECTS)" "INCLUDES=$(INCLUDES)" \
		"DEFS=$(DEFS)" "LIBS=$(LIBS)" "CFLAGS=$(CFLAGS)" \
		"ADDSYMBOLS=$(ADDSYMBOLS)" $(SETFILTER) \
		"MYINCLUDES=$(MYINCLUDES)"

.SUFFIXES:	.c .obj .lib

.c.obj:
	$(MAKE2) $*.obj


dynamic: $(LIB).dll $(LIB)_import.a $(LIB)_import.lib

definition: $(LIB).def

$(LIB).dll $(LIB)_import.a $(LIB)_import.lib : $(LIB).def $(OBJECTS)
	$(MAKE2)

$(LIB).def:
	$(MAKE2) definition

smartdefinition: $(LIB).def
	$(MAKE2) smartdefinition

re_smartdefinition: $(LIB).def
	$(MAKE2) re_smartdefinition

install: $(LIB).def $(LIB).dll $(LIB)_import.a $(LIB)_import.lib
	$(MAKE2) install 

clean:
	-$(RM) $(OBJECTS) $(LIB).dll $(LIB).lib $(LIB)_import.a $(LIB)_import.lib tmptmp.tmp $(LIB).tmp 2> nul

realclean: clean
	-$(RM) $(LIB).def 2> nul
